routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\MarcaController;
use App\Http\Controllers\ModeloController;
use App\Http\Controllers\SessionController;
use App\Http\Controllers\RegisterController;
use App\Http\Controllers\VehiculoController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

// rutas de los CRUDS
Route::resource('modelos', ModeloController::class)->middleware('auth');
Route::resource('marcas', MarcaController::class)->middleware('auth');
Route::resource('vehiculos', VehiculoController::class)->middleware('auth');

// rutas de autenticación
Route::get('/register', [RegisterController::class, 'create'])->name('auth.register');
Route::post('/register', [RegisterController::class, 'store'])->name('auth.store');
Route::get('/login', [SessionController::class, 'create'])->name('auth.login');
Route::post('/home', [SessionController::class, 'entrar'])->name('auth.entrar');
Route::get('/logout', [SessionController::class, 'destroy'])->name('auth.destroy')->middleware('auth');

// ruta para filtrar modelos por la marca
Route::get('/brands/list/{brand}', [ModeloController::class, 'lista'])->name('brand.lista')->middleware('auth');

app/Models/Modelo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Modelo extends Model
{
    use HasFactory;

    protected $table = "modelos";
    
    protected $fillable = [
        'name',
        'description',
    ];

    public function marca() {
        return $this->belongsTo(Marca::class, 'id_brand');        
    }

    public function vehiculo()
    {
        return $this->hasMany(Vehiculo::class, 'id_model');
    }
}

app/Http/Controllers/ModeloController.php
<?php

namespace App\Http\Controllers;

use App\Models\Marca;
use App\Models\Modelo;
use Illuminate\Http\Request;

class ModeloController extends Controller
{
    // función para llamar la tabla con todos los registros
    public function index(){
        $modelos = Modelo::where('status', '=', 1)->with('marca')->get();
        return view('modelos.index', compact('modelos'));
    }

    // función para llamar el formulario
    public function create(){
        $marcas = Marca::where('status', '=', 1)->get();
        return view('modelos.create', compact('marcas'));
    }

    // función para guardar un registro nuevo
    public function store(Request $request){
        $request->validate([
            'name' => 'required|max:30',
            'description' => 'required|max:90',
        ]);
        $modelos = new Modelo();
        $modelos->name = $request->name;
        $modelos->description = $request->description;
        $modelos->id_brand = $request->id_brand;
        $modelos->save();
        return response()->json(['success' => true]);
    }

    // función para llamar el formulario con información del registro a editar
    public function edit($id){
        $modelos = Modelo::where('id', '=', $id)->with('marca')->get()->first();
        $marcas = Marca::where('status', '=', 1)->get();
        return view('modelos.edit', compact('modelos', 'marcas'));

    }

    // función para modificar un registro
    public function update(Request $request, $id){
        $request->validate([
            'name' => 'required|max:30',
            'description' => 'required|max:90',
        ]);
        $modelos = Modelo::where('id', '=', $id)->get()->first();
        $modelos->name = $request->name;
        $modelos->description = $request->description;
        $modelos->id_brand = $request->id_brand;
        $modelos->save();
        return response()->json(['success' => true]);
    }

    // función para eliminar logicamente un registro
    public function destroy($id){
        $modelos = Modelo::where('id', '=', $id)->get()->first();
        $modelos->status = '0';
        $modelos->save();
        return response()->json(['success' => true]);
    }

    // funcion que retorna una lista de modelos filtrados por la marca
    public function lista($id){
        $modelos = Modelo::where([
            ['status', '=', '1'],
            ['id_brand','=',$id]
        ])->with('marca')->get();

        $modelsNotFound[] = ['id'=> 'null', 'name' => 'Esta marca no tiene modelos de vehiculos asociados'];

        count($modelos) === 0 ? $modelos = $modelsNotFound : $modelos;

        return $modelos;
        
    }
}

resources/views/modelos/create.blade.php
@extends('layouts.index')

@section('content')
    <div class="">
        <form action="" id="formModelo" method="post">
            @csrf   
            <div class="form-group mb-3 mt-5">
                <div class="form-group mb-3">
                    <label for="">Nombre:</label>
                    <input type="text" name="name" id="name" class="form-control" placeholder="escribe una nombre" autofocus aria-describedby="helpId" required>
                </div>
                <div class="form-group mb-3">
                    <label for="">Descripcion:</label>
                    <input type="text" name="description" id="description" class="form-control" placeholder="escribe una descripcion" aria-describedby="helpId" required>
                </div>
            </div>
            <div class="form-group mb-3">
                <label for="">Marca:</label>
                <select class="form-control" name="id_brand" id="id_brand" required>
                    <option>Seleccione una marca</option>
                    @foreach ($marcas as $marca)
                        <option value="{{$marca->id}}">{{$marca->name}}</option>
                    @endforeach
                </select>
            </div>
            <div class="float-right">
                <button class="btn btn-success" id="btnRegistrarModelo">Registrar</button>
                <a class="btn btn-warning" href="{{route('modelos.index')}}" id="btnRegistrarVehiculo">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@section('javascript')

    <!-- Petición ajax para guardar un registro en la base de datos -->
    <script>
        $('#btnRegistrarModelo').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let name  = $('#name').val();
            let description = $('#description').val();
            let _token = $('input[name=_token]').val();
            let id_brand = $('#id_brand').val();
            // Petición ajax
            $.ajax({
                type: "POST",
                url: "{{route('modelos.store')}}",
                data: {
                    name: name,
                    description: description,
                    id_brand: id_brand,
                    _token: _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Registro exitoso', 'Nuevo registro');
                        window.location.href = '/modelos'
                    }, 1000);
                },
                error: function (err) {
                    if (err.status == 422) { // when status code is 422, it's a validation issue
                        $.each(err.responseJSON.errors, function (i, error) {
                            var el = $(document).find('[name="'+i+'"]');
                            el.after($('<span style="color: red;">'+error[0]+'</span>'));
                        });
                    }
                }
            });
        });
    </script>
@endsection

resources/views/modelos/edit.blade.php
@extends('layouts.index')

@section('content')
    <div class="">
        <form action="" id="formModelo" method="post">
            @csrf   
            <div class="form-group mb-3 mt-5">
                <div class="form-group mb-3">
                    <label for="">Nombre:</label>
                    <input type="text" name="name" id="name" class="form-control" placeholder="escribe una nombre" autofocus aria-describedby="helpId" value="{{$modelos->name}}" required>
                </div>
                <div class="form-group mb-3">
                    <label for="">Descripcion:</label>
                    <input type="text" name="description" id="description" class="form-control" placeholder="escribe una descripcion" aria-describedby="helpId" value="{{$modelos->description}}" required>
                </div>
            </div>
            <div class="form-group mb-3">
                <label for="">Marca:</label>
                <select class="form-control" name="id_brand" id="id_brand" required>
                    <option>Seleccione una marca</option>
                    @foreach ($marcas as $marca)
                        <option value="{{$marca->id}}" {{$modelos->id_brand == $marca->id ? 'selected' : ''}}>{{$marca->name}}</option>
                    @endforeach
                </select>
            </div>
            <div class="float-right">
                <button class="btn btn-success" id="btnRegistrarModelo">Registrar</button>
                <a class="btn btn-warning" href="{{route('modelos.index')}}" id="btnRegistrarVehiculo">Atras</a>
            </div>
        </form>
    </div> 
@endsection

@section('javascript')

    <!-- Petición ajax para modificar un registro en la base de datos -->
    <script>
        $('#btnRegistrarModelo').on('click', function(e){
            e.preventDefault();
            // obtener valores de los inputs
            let name  = $('#name').val();
            let description = $('#description').val();
            let _token = $('input[name=_token]').val();
            let id_brand = $('#id_brand').val();
            // Petición ajax
            $.ajax({
                type: "PUT",
                url: "{{route('modelos.update', $modelos->id)}}",
                data: {
                    name: name,
                    description: description,
                    id_brand: id_brand,
                    _token: _token
                },
                success:function(response){
                    setTimeout(() => {
                        toastr.success('Modificación exitosa', 'Modificar registro');
                        window.location.href = '/modelos'
                    }, 1000);
                },
                error: function (err) {
                    if (err.status == 422) { // when status code is 422, it's a validation issue
                        $.each(err.responseJSON.errors, function (i, error) {
                            var el = $(document).find('[name="'+i+'"]');
                            el.after($('<span style="color: red;">'+error[0]+'</span>'));
                        });
                    }
                }
            });
        });
    </script>
@endsection

resources/views/modelos/index.blade.php
@extends('layouts.index')

@section('content')

    <div class="container">
        <div class="row mb-5 mt-5">
            <div class="col-md-6" style="display:flex;">
                <h3 class="text-secondary">Modelos</h3>
                <a href="" class="btn btn-primary" style="margin-left: 30px;" id="btnNuevaModelo">Nuevo modelo</a>
            </div>
            <div class="col-md-6">
            </div>
        </div>
    </div>
    <div class="col-md-12">
        <table class="table cell-border" id="table-generic">
            <thead class="thead-light">
                <tr>
                    <th class="text-center">ID</th>
                    <th class="text-center">NOMBRE</th>
                    <th class="text-center">DESCRIPCIÓN</th>
                    <th class="text-center">MARCA</th>
                    <th class="text-center">ACCIONES</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($modelos as $modelo)
                    <tr id="rowId-{{$modelo->id}}">
                        <td class="text-center">
                            {{$modelo->id}}
                        </td>
                        <td class="text-center">
                            {{$modelo->name}}
                        </td>
                        <td class="text-center">
                            {{$modelo->description}}
                        </td>
                        <td class="text-center">
                            {{$modelo->marca->name}}
                        </td>
                        <td class="text-center">
                            <div class="btn-group">
                                <a href="{{route('modelos.edit',$modelo->id)}}" id="editBtn" class="btn btn-warning" title="Modificar">Editar</a>
                                <form action="" style="display: inline" method="post">
                                    @csrf
                                    @method('DELETE')
                                    <button id="btnDelete" valor="{{$modelo->id}}" class="btn btn-danger" title="Eliminar"> Eliminar </button>
                                </form>
                            </div>
                        </td>
                    </tr>
                @endforeach
            </tbody>
        </table>
        <div class="col-md-12">
            <form action="" method="get">
                <button class="btn btn-warning" type="submit">Back</button>
            </form>
        </div>
    </div>

@endsection

@section('javascript')

    <!-- Petición ajax para llamar a la vista create -->
    <script>
        $('#btnNuevaModelo').on('click', function(e){
            // Petición ajax
            $.ajax({
                type: "GET",
                url: "{{route('modelos.create')}}",
                success: function() { 
                    window.location.href = '/modelos/create'
                },
                error: function(xhr, ajaxOptions, thrownerror) { }
            })
        });
    </script>
    <script>
        // Ajax para eliminar un registro
        $(document).on('click', '#btnDelete', function(e){
            if(confirm('Está seguro que quiere eliminar este registro?')){
                e.preventDefault();
                let id = $(this).attr('valor');
                let _token = $('input[name=_token]').val();
                $.ajax({
                    type: "DELETE",
                    url: `modelos/${id}`,
                    data: {
                        id: id,
                        _token: _token
                    },
                    success:function(response){
                        toastr.success('Registro Eliminado', 'Eliminar', 3000);
                        $('#rowId-'+id).remove();
                    },
                    error: function (err) {
                        if(err.status == 422){
                            $.each(err.responseJSON.errors, function (i,error) {
                                toastr.success('error en eliminacion', +error[0], 3000);
                            })
                        }
                    }
                });
            }
        });
    </script>
@endsection